#include <libsegy.h>
#include "segy_matlab.h"
#include <mex.h>
#include <matrix.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// mexfunction(out_argc, out_argv, in_argc, in_argv)
//   out_argc: int = number of output arguments requested by caller
//   out_argv: mxArray * = hooks to assign output args to
//   in_argc : int = number of input arguments assigned by caller
//   in_argv : mxArray * = input argument pointers
//
//   in_argv[0] : int = open file descriptor
//   out_argv[0]: int = 0 on success, nonzero on error
//
void mexFunction(int out_argc,  mxArray *out_argv[], 
                 int in_argc, const mxArray *in_argv[])
{
  int fd = 0; int err = 0;

  // check input arguments
  if (in_argc < 1 || ! mxIsInt32(in_argv[0]) || mxIsEmpty(in_argv[0])) {
    mexPrintf("segy_close_file: input must be a file descriptor\n");
    return;
  }
  if (mxGetPr(in_argv[0])) fd = ((int*)mxGetPr(in_argv[0]))[0];
  else {
    mexPrintf("segy_close_file: out of memory\n");
    return;
  }

  // check ouput arguments
  if (out_argc < 1) {
    mexPrintf("segy_close_file: must have one output argument\n");  
    return;
  }

  // close descriptor
  err = segy_close_file(fd);
  out_argv[0] = mxCreateNumericMatrix(1,1,mxINT32_CLASS,mxREAL);
  if (out_argv[0]) ((int*)mxGetPr(out_argv[0]))[0] = err;
  else {
    mexPrintf("segy_close_file: out of memory\n");
    return;
  }
}
