#include <windows.h>

typedef void (*type1)(char *, int);
type1 segy_ebcdic2ascii;
type1 segy_ascii2ebcdic;

typedef int (*type2)(short, const char *, int, float *, short);
type2 convert2ieee;
type2 convert2segy;

typedef const char * (*type3)(int);
type3 segy_error_message;

typedef int (*type4)(const char *);
type4 segy_open_file;

typedef int (*type5)(int);
type5 segy_close_file;

typedef int (*type6)(int, segy_file_header *);
type6 segy_read_file_header;

typedef int (*type7)(int, const segy_file_header *);
type7 segy_write_file_header;

typedef int (*type8)(int, int);
type8 segy_seek_trace;

typedef int (*type9)(int, int, segy_trace_header *, float *, short);
type9 segy_read_trace;

typedef int (*type10)(int, int, int, float *, short);
type10 segy_read_data;

typedef int (*type11)(int, int, const segy_trace_header *, const float *, short);
type11 segy_write_trace;

#define LOAD_DLL \
HINSTANCE hinstLib = LoadLibrary("libsegy.dll"); \
if (hinstLib == NULL) { \
  printf("ERROR: unable to load libsegy.dll\n"); \
  return 1; \
} \
 \
segy_ebcdic2ascii = (type1)GetProcAddress(hinstLib, "segy_ebcdic2ascii"); \
segy_ascii2ebcdic = (type1)GetProcAddress(hinstLib, "segy_ascii2ebcdic"); \
segy_convert2ieee = (type2)GetProcAddress(hinstLib, "segy_convert2ieee"); \
segy_convert2segy = (type2)GetProcAddress(hinstLib, "segy_convert2segy"); \
segy_error_message = (type3)GetProcAddress(hinstLib, "segy_error_message"); \
segy_open_file = (type4)GetProcAddress(hinstLib, "segy_open_file"); \
segy_close_file = (type5)GetProcAddress(hinstLib, "segy_close_file"); \
segy_read_file_header = (type6)GetProcAddress(hinstLib, "segy_read_file_header"); \
segy_write_file_header = (type7)GetProcAddress(hinstLib, "segy_write_file_header"); \
segy_seek_trace = (type8)GetProcAddress(hinstLib, "segy_seek_trace"); \
segy_read_trace = (type9)GetProcAddress(hinstLib, "segy_read_trace"); \
segy_read_data = (type10)GetProcAddress(hinstLib, "segy_read_data"); \
segy_write_trace = (type11)GetProcAddress(hinstLib, "segy_write_trace"); \
 \
if (segy_ebcdic2ascii == NULL || segy_ascii2ebcdic == NULL || \
    segy_convert2ieee == NULL || segy_convert2segy == NULL || \
    segy_error_message == NULL || segy_open_file == NULL || \
    segy_read_file_header == NULL || segy_write_file_header == NULL || \
    segy_seek_trace == NULL || segy_read_trace == NULL || \
    segy_read_data == NULL || segy_write_trace == NULL) { \
  printf("Error: loading of one or more libsegy functions failed\n"); \
  FreeLibrary(hinstLib); \
  return 1; \
}