#!/usr/bin/perl -w
use strict;

my @labels;
while (<STDIN>) {
    my $line = $_;
    if ($line =~ /^\s*(\w+)\s+(\w+);.*$/) {
      my ($type, $label) = $line =~ /^\s*(\w+)\s+(\w+);.*$/;
      if ($type =~ /int/) {
	  print "  if ( (field = mxGetField(in_argv[1], 0, \"$label\"))\n";
	  print "      && ! mxIsEmpty(field) && mxIsNumeric(field))\n";
	  print "    header.$label = (int)mxGetScalar(field);\n";
          print "  else mexErrMsgTxt(\"Error: field $label invalid\");\n\n"
      }
      if ($type =~ /short/) {
	  print "  if ( (field = mxGetField(in_argv[1], 0, \"$label\"))\n";
	  print "      && ! mxIsEmpty(field) && mxIsNumeric(field))\n";
	  print "    header.$label = (short)mxGetScalar(field);\n";
          print "  else mexErrMsgTxt(\"Error: field $label invalid\");\n\n"
      }
  }
    elsif ($line =~ /^\s*char\s+(\w+)\[(\d+)\];.*$/) {
	my ($label, $size) = $line =~ /^\s*char\s+(\w+)\[(\d+)\];.*$/;
	print "  if ( (field = mxGetField(in_argv[1], 0, \"$label\"))\n";
	print "      && ! mxIsEmpty(field) && mxIsChar(field)) {\n";
	print "    for (i=0; i<$size; i++) \n";
        print "      header.$label"."[i] = ((short*)mxGetPr(field))[i]; \n";
        print "  }\n";
        print "  else mexErrMsgTxt(\"Error: field $label invalid\");\n\n" 
    }

    else {
	print "\n";
    }  
}
