#!/usr/bin/perl -w
use strict;

my @labels;
while (<STDIN>) {
    my $line = $_;
    if ($line =~ /^\s*(\w+)\s+(\w+);.*$/) {
      my ($type, $label) = $line =~ /^\s*(\w+)\s+(\w+);.*$/;
      if ($type =~ /int/) {
	  print "  printf(\"%-25s: %5d (%s)\\n\", \"$label\",\n";
	  print "         head.$label, printint(&head.$label));\n\n";	  
      }
      if ($type =~ /short/) {
	  print "  printf(\"%-25s: %5d (%s)\\n\", \"$label\",\n";
	  print "         head.$label, printshort(&head.$label));\n\n";	  
      }
  }
    elsif ($line =~ /^\s*char\s+(\w+)\[(\d+)\];.*$/) {
	my ($label, $size) = $line =~ /^\s*char\s+(\w+)\[(\d+)\];.*$/;
	print "  printf(\"%-25s:  \", \"$label\[$size\]\");\n";
	print "  for (i = 0; i < $size && i < 40; i++) {\n";
	print "    if (i == 0) printf(\"'\");\n";
        print "    printf(\"%hhx\", head.$label\[i\]);\n";
	print "    if (i == 39) printf(\"...'\\n\");\n";
	print "  }\n\n";
    }

    else {
	print "\n";
    }  
}
