#!/usr/bin/perl -w
use strict;

while (<STDIN>) {
    my $line = $_;
    if ($line =~ /^\s*(\w+)\s+(\w+);.*$/) {
      my ($type, $label) = $line =~ /^\s*(\w+)\s+(\w+);.*$/;
      if ($type =~ /int/) {
	  print "  mxSetField(out_argv[0], 0, \"$label\", ";
	  print "mxCreateNumericMatrix(1,1,mxINT32_CLASS,mxREAL));\n\n";
      }
      if ($type =~ /short/) {
	  print "  mxSetField(out_argv[0], 0, \"$label\", ";
	  print "mxCreateNumericMatrix(1,1,mxINT16_CLASS,mxREAL));\n\n";
      }
  }
    elsif ($line =~ /^\s*char\s+(\w+)\[(\d+)\];.*$/) {
	my ($label, $size) = $line =~ /^\s*char\s+(\w+)\[(\d+)\];.*$/;
	print "  size[0] = 1; size[1] = $size;\n";
	print "  mxSetField(out_argv[0], 0, \"$label\", ";
	print "mxCreateCharArray(2, size));\n\n";
    }
      
    else {
	print "\n";
    }  
}

